<?php

namespace ID\IndexedSearchAutocomplete\Controller;

use ID\IndexedSearchAutocomplete\Service\SearchService;
use Psr\Http\Message\ResponseInterface;
use TYPO3\CMS\Extbase\Mvc\Controller\ActionController;
/**
 * SearchController
 *
 * This controller receives the search and handles them.
 */
class SearchController extends ActionController
{

    /**
     * Search functions
     *
     * @var SearchService
     */
    protected $searchService = null;

    /**
     * @param SearchService $searchService
     */
    public function injectSearchService(SearchService $searchService)
    {
        $this->searchService = $searchService;
    }
    
    /**
     * action search
     *
     * @return string
     */
    public function SearchAction(): ResponseInterface
    {

        // Fetch the request
        $arg = $_REQUEST;

        // Check which search to perform
        if ($arg['m'] == 'word') {
            $result = $this->searchService->searchAWord($arg);
        } else {
            $result = $this->searchService->searchASite($arg);
        }

        // Assign the results
        foreach ($result as $key => $value) {
            $this->view->assign($key, $value);
        }
        return $this->htmlResponse($this->view->render());        
    }
}
